> {-# OPTIONS -cpp #-}
> module Interrupt where
>
> import System.IO

#if defined(mingw32_HOST_OS)

> import qualified GHC.ConsoleHandler as S

#else

> import qualified System.Posix.Signals as S

#endif

> import Control.Exception
> import Prelude hiding (catch)
> import Control.Concurrent
>

#if defined (mingw32_HOST_OS)

> installHandler h = S.installHandler (S.Catch int)
>   where int S.Break = h
>         int S.ControlC = h
>         int _ = return ()

#else

> installHandler h = S.installHandler S.sigINT  (S.Catch h) Nothing
> installHandler h = S.installHandler S.sigQUIT (S.Catch h) Nothing

#endif

